/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.concurrency;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

import net.sourceforge.mysources.thinkinjava4.utils.Print;


/**
 * 使用新的DaemonThreadFactory作为参数传递给
 * Executor.newCachedThreadPool
 *
 * @author Lucky Yang
 * @since 0.1
 */
public class DaemonFromFactory{

	/**
	 * @param args
	 * @throws InterruptedException 
	 */
	public static void main(String[] args) throws InterruptedException {
		ExecutorService exec = Executors.newCachedThreadPool(
				new DaemonThreadFactory());
//		ExecutorService exec = new DaemonThreadPoolExecutor();		
		for(int i = 0; i < 10; i++)
			exec.execute(new SimpleDaemons());

		Print.print("All daemons started");
		TimeUnit.MICROSECONDS.sleep(175);
	}	

}
