/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.concurrency;

import net.sourceforge.mysources.thinkinjava4.utils.Print;
/**
 * 定义任务
 *
 * @author Lucky Yang
 * @since 0.1
 */
public class LiftOff implements Runnable {
	protected int countDown = 10; // default
	private static int taskCount = 0;
	private final int id = taskCount ++ ;
	
	public LiftOff() {
		super();
	}

	public LiftOff(int countDown) {
		super();
		this.countDown = countDown;
	}

	public String status(){
		return "#" + id + "(" +
			(countDown > 0 ? countDown : "Lifftoff!") + ").";
	}
	
	@Override
	public void run() {
		while(countDown-- > 0){
			//for(int i = 0; i < 1000000; i++);
			Print.print(status());
			Thread.yield();
		}

	}

}
