/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.concurrency;

import java.util.concurrent.TimeUnit;

import net.sourceforge.mysources.thinkinjava4.utils.Print;
/**
 * 后台线程
 *
 * @author Lucky Yang
 * @since 0.1
 */
public class SimpleDaemons implements Runnable {

	@Override
	public void run() {
		try{
			while(true){		
				TimeUnit.MICROSECONDS.sleep(100);
				Print.print(Thread.currentThread() + " " + this);
			}
		} catch(InterruptedException e){
			Print.print("sleep() interrupted");
		}

	}

	/**
	 * @param args
	 * @throws InterruptedException 
	 */
	public static void main(String[] args) throws InterruptedException {
		for(int i = 0; i < 10; i++){
			Thread daemon = new Thread(new SimpleDaemons());
			daemon.setDaemon(true); // Must call before start()
			daemon.start();
		}
		Print.print("All daemons started");
		TimeUnit.MICROSECONDS.sleep(175);
	}	
}
