/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.concurrency;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import net.sourceforge.mysources.thinkinjava4.utils.Print;
/**
 * 优先级
 *
 * @author Lucky Yang
 * @since 0.1
 */
public class SimplePriorities implements Runnable {
	private int countDown = 5;
	private volatile double d; // No optimization
	private int prioprity;
	
	private SimplePriorities(int prioprity) {
		super();
		this.prioprity = prioprity;
	}

	@Override
	public void run() {
		Thread.currentThread().setPriority(prioprity);
		while(true){
			// An expensive, interruptable operation:
			for(int i = 1; i < 1000000; i++){
				d += (Math.PI + Math.E)/(double)i;
				if (i % 1000 == 0)
					Thread.yield();
			}
			Print.print(this);
			if (--countDown == 0) return;
		}
		
	}

	@Override
	public String toString() {
		return Thread.currentThread() + ": " +  countDown;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ExecutorService exec = Executors.newCachedThreadPool();
		for(int i = 0; i < 5; i++)
			exec.execute(new SimplePriorities(Thread.MIN_PRIORITY));
		
		exec.execute(new SimplePriorities(Thread.MAX_PRIORITY));
		exec.shutdown();
	}	
}
