/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.concurrency;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

import net.sourceforge.mysources.thinkinjava4.utils.Print;


/**
 * 休眠
 *
 * @author Lucky Yang
 * @since 0.1
 */
public class SleepingTask extends LiftOff {

	@Override
	public void run() {
		try {
			while(countDown-- > 0){
				Print.print(this.status());
				// Old-style:
				// Thread.sleep(100);
				// Java SE5/6-style
				TimeUnit.MICROSECONDS.sleep(100);
			}
		} catch(InterruptedException e){
			Print.print("Interrupted");
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ExecutorService exec = Executors.newCachedThreadPool();
		for(int i = 0; i < 5; i++)
			exec.execute(new SleepingTask());
		exec.shutdown();
	}	
}
