/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.containers;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import net.sourceforge.mysources.thinkinjava4.utils.Countries;
import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * Things you can do with all Collections
 * 
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2013-2-25
 * @since 1.1.2
 */
public class CollectionMethods {
	public static void main(String[] args) {
		Collection<String> c = new ArrayList<String>();
		c.addAll(Countries.names(6));
		c.add("ten");
		c.add("eleven");
		Print.print(c);
		// Make an array from the List:
		Object[] array = c.toArray();
		// Make a String array from the List:
		String[] str = c.toArray(new String[0]);
		// Find max and min elements; this means
		// different things depending on the way
		// the Comparable interface is implemented:
		Print.print("Collections.max(c) = " + Collections.max(c));
		Print.print("Collections.min(c) = " + Collections.min(c));
		// Add a Collection to another Collection
		Collection<String> c2 = new ArrayList<String>();
		c2.addAll(Countries.names(6));
		c.addAll(c2);
		Print.print(c);
		c.remove(Countries.DATA[0][0]);
		Print.print(c);
		c.remove(Countries.DATA[1][0]);
		Print.print(c);
		// Remove all components that are
		// in the argument collection:
		c.removeAll(c2);
		Print.print(c);
		c.addAll(c2);
		Print.print(c);
		// Is an element in this Collection?
		String val = Countries.DATA[3][0];
		Print.print("c.contains(" + val + ") = " + c.contains(val));
		// Is a Collection in this Collection?
		Print.print("c.containsAll(c2) = " + c.containsAll(c2));
		Collection<String> c3 = ((List<String>) c).subList(3, 5);
		// Keep all the elements that are in both
		// c2 and c3 (an intersection of sets):
		c2.retainAll(c3);
		Print.print(c2);
		// Throw away all the elements
		// in c2 that also appear in c3:
		c2.removeAll(c3);
		Print.print("c2.isEmpty() = " + c2.isEmpty());
		c = new ArrayList<String>();
		c.addAll(Countries.names(6));
		Print.print(c);
		c.clear(); // Remove all elements
		Print.print("after c.clear():" + c);
	}
}
