/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.containers;

import java.util.LinkedHashMap;

import net.sourceforge.mysources.thinkinjava4.utils.CountingMapData;
import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * What you can do with a LinkedHashMap
 *
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2013-2-24
 * @since 1.1.2
 */
public class LinkedHashMapDemo {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		LinkedHashMap<Integer, String> linkedMap = new LinkedHashMap<Integer, String>(
				new CountingMapData(9));
		Print.print(linkedMap);
		// Least-recently-used order:
		linkedMap = new LinkedHashMap<Integer, String>(16, 0.75f, true);
		linkedMap.putAll(new CountingMapData(9));
		Print.print(linkedMap);
		for (int i = 0; i < 6; i++)
			// Cause accesses:
			linkedMap.get(i);
		Print.print(linkedMap);
		linkedMap.get(0);
		Print.print(linkedMap);

	}

}


