/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.containers;

import java.util.Iterator;

import net.sourceforge.mysources.thinkinjava4.utils.CountingGenerator;
import net.sourceforge.mysources.thinkinjava4.utils.Generator;
import net.sourceforge.mysources.thinkinjava4.utils.MapData;
import net.sourceforge.mysources.thinkinjava4.utils.Pair;
import net.sourceforge.mysources.thinkinjava4.utils.Print;
import net.sourceforge.mysources.thinkinjava4.utils.RandomGenerator;

/**
 * 测试MapData类
 *
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2012-12-29
 * @since 1.1.2
 */
class Letters implements Generator<Pair<Integer,String>>, Iterable<Integer>{
	private int size = 9;
	private int number = 1;
	private char letter = 'A';
	
	@Override
	public Iterator<Integer> iterator() {
		return new Iterator<Integer>(){

			@Override
			public boolean hasNext() {
				return number < size;
			}

			@Override
			public Integer next() {
				return number++;
			}

			@Override
			public void remove() {
				throw new UnsupportedOperationException();				
			}
			
		};
	}

	@Override
	public Pair<Integer, String> next() {
		return new Pair<Integer, String>(
				number++, "" + letter++);
	}
	
}
public class MapDataTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// Pair Generator
		Print.print(MapData.map(new Letters(), 11));
		// Two separate generators
		Print.print(MapData.map(new CountingGenerator.Character(),
				new RandomGenerator.String(3), 8));
		// A key Generator and a single value
		Print.print(MapData.map(new CountingGenerator.Character(), 
				"Value", 6));
		// An Iterable and a value Generator
		Print.print(MapData.map(new Letters(), new RandomGenerator.String(3)));
		// An Iterable and a single value
		Print.print(MapData.map(new Letters(), "Pop"));
	}

}


