/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.containers;

import java.util.HashMap;
import java.util.IdentityHashMap;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.TreeMap;
import java.util.WeakHashMap;
import java.util.concurrent.ConcurrentHashMap;

import net.sourceforge.mysources.thinkinjava4.utils.CountingMapData;
import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * Things you can do with Maps
 *
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2013-2-24
 * @since 1.1.2
 */
public class Mps {
	public static void printKeys(Map<Integer, String> map){
		Print.printnb("Size = " + map.size() + ", ");
		Print.printnb("Keys: ");
		Print.printnb(map.keySet()); // Produce a set of the keys
	}
	
	public static void test(Map<Integer, String> map){
		Print.print(map.getClass().getSimpleName());
		map.putAll(new CountingMapData(25));
		// Map has 'Set' behavior for keys:
		map.putAll(new CountingMapData(25));
		printKeys(map);
		// Producting a Collection of the values:
		Print.printnb("Values: ");
		Print.print(map.values());
		Print.print(map);
		Print.print("map.containsKey(11): " + map.containsKey(11));
		Print.print("map.get(11):" + map.get(11));
		Print.print("map.containsValue(\"F0\"): " + map.containsValue("F0"));
		Integer key = map.keySet().iterator().next();
		map.remove(key);
		printKeys(map);
		map.clear();
		Print.print("map.isEmpty(): " + map.isEmpty());
		map.putAll(new CountingMapData(25));
		// Operations on the Set change the Map:
		map.keySet().removeAll(map.keySet());
		Print.print("map.isEmpty(): " + map.isEmpty());
	}
	
	public static void main(String[] args) {
		test(new HashMap<Integer, String>());
		test(new TreeMap<Integer, String>());
		test(new LinkedHashMap<Integer, String>());
		test(new IdentityHashMap<Integer, String>());
		test(new ConcurrentHashMap<Integer, String>());
		test(new WeakHashMap<Integer, String>());
	}
}


