/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.containers;

import java.util.LinkedList;
import java.util.PriorityQueue;
import java.util.Queue;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.ConcurrentLinkedQueue;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.PriorityBlockingQueue;

import net.sourceforge.mysources.thinkinjava4.utils.Generator;
import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * Queue队列的基本操纵。
 *
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2013-2-24
 * @since 1.1.2
 */
public class QueueBehavior {
	private static int count = 10;
	static <T> void test(Queue<T> queue, Generator<T> gen){
		for(int i = 0; i < count; i++)
			queue.offer(gen.next());
		while(queue.peek() != null)
			Print.printnb(queue.remove() + " ");
		Print.print();
	}
	
	static class Gen implements Generator<String>{
		String[] s = ("one two three four five six seven " +
				"eight nine tem").split(" ");
		int i;
		@Override
		public String next() {
			return s[i++];
		}
		
	}
	
	public static void main(String[] args){
		test(new LinkedList<String>(), new Gen());
		test(new PriorityQueue<String>(), new Gen());
		test(new ArrayBlockingQueue<String>(count), new Gen());
		test(new ConcurrentLinkedQueue<String>(), new Gen());
		test(new LinkedBlockingQueue<String>(), new Gen());
		test(new PriorityBlockingQueue<String>(), new Gen());
	}
}


