/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.containers;

import java.util.Iterator;
import java.util.TreeMap;

import net.sourceforge.mysources.thinkinjava4.utils.CountingMapData;
import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * What you can do with a TreeMap
 *
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2013-2-24
 * @since 1.1.2
 */
public class SortedMapDemo {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		TreeMap<Integer, String> sortedMap = new TreeMap<Integer, String>(
				new CountingMapData(10));
		Print.print(sortedMap);
		Integer low = sortedMap.firstKey();
		Integer high = sortedMap.lastKey();
		Print.print(low);
		Print.print(high);
		Iterator<Integer> it = sortedMap.keySet().iterator();
		for (int i = 0; i <= 6; i++) {
			if (i == 3)
				low = it.next();
			if (i == 6)
				high = it.next();
			else
				it.next();
		}
		Print.print(low);
		Print.print(high);
		Print.print(sortedMap.subMap(low, high));
		Print.print(sortedMap.headMap(high));
		Print.print(sortedMap.tailMap(low));
	}

}


