/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.containers;

import java.lang.reflect.Constructor;
import java.util.HashMap;
import java.util.Map;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 春天探测者
 * <p>
 * What will the weather be?
 * 
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2013-2-25
 * @since 1.1.2
 */
public class SpringDetector {
	// Uses a Groundhog or class derived from Groundhog:
	public static <T extends Groundhog> void detectSpring(Class<T> type)
			throws Exception {
		Constructor<T> ghog = type.getConstructor(int.class);
		Map<Groundhog, Prediction> map = new HashMap<Groundhog, Prediction>();
		for (int i = 0; i < 10; i++)
			map.put(ghog.newInstance(i), new Prediction());
		Print.print("map = " + map);
		Groundhog gh = ghog.newInstance(3);
		Print.print("Looking up prediction for " + gh);
		if (map.containsKey(gh))
			Print.print(map.get(gh));
		else
			Print.print("Key not found: " + gh);
	}

	public static void main(String[] args) throws Exception {
		detectSpring(Groundhog.class);
	}
}
