/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.containers;

import java.util.PriorityQueue;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 优先级队列 
 *
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2013-2-24
 * @since 1.1.2
 */
public class ToDoList extends PriorityQueue<ToDoList.ToDoItem> {
	/**
	 * 
	 */
	private static final long serialVersionUID = 3737894323275302897L;

	static class ToDoItem implements Comparable<ToDoItem>{
		private char primary;
		private int secondary;
		private String item;
		
		public ToDoItem(String td, char pri, int sec) {
			this.primary = pri;
			this.secondary = sec;
			this.item = td;
		}

		@Override
		public int compareTo(ToDoItem o) {
			if (primary > o.primary)
				return +1;
			if (primary == o.primary)
				if(secondary > o.secondary)
					return +1;
				else if (secondary == o.secondary)
					return 0;
			return -1;
		}

		@Override
		public String toString() {
			return Character.toString(primary) + secondary + ": " + item;
		}		
	}


	public boolean add(String td, char pri, int sec) {
		return super.add(new ToDoItem(td, pri, sec));
	}
	
	public static void main(String[] args){
		ToDoList toDoList = new ToDoList();
		toDoList.add("Empty trash", 'C', 4);
		toDoList.add("Feed dog", 'A', 2);
		toDoList.add("Feed bird", 'B', 7);
		toDoList.add("Mow lawn", 'C', 3);
		toDoList.add("Water lawn", 'A', 1);
		toDoList.add("Feed cat", 'B', 1);
		while(!toDoList.isEmpty())
			Print.print(toDoList.remove());
	}
}


