/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.containers;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * Unsupported operations in Java containers.
 * 
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2012-12-30
 * @since 1.1.2
 */
public class Unsupported {
	static void test(String msg, List<String> list) {
		Print.print("--- " + msg + " ---");
		Collection<String> c = list;
		Collection<String> subList = list.subList(1, 8);

		// Copy of the sublist
		Collection<String> c2 = new ArrayList<String>(subList);
		try {
			c.retainAll(c2);
		} catch (Exception e) {
			Print.print("retainAll(): " + e);
		}
		try {
			c.removeAll(c2);
		} catch (Exception e) {
			Print.print("removeAll(): " + e);
		}
		try {
			c.clear();
		} catch (Exception e) {
			Print.print("clear(): " + e);
		}
		try {
			c.add("X");
		} catch (Exception e) {
			Print.print("add(): " + e);
		}
		try {
			c.addAll(c2);
		} catch (Exception e) {
			Print.print("addAll(): " + e);
		}
		try {
			c.remove("C");
		} catch (Exception e) {
			Print.print("remove(): " + e);
		}
		// The List.set() method modifies the value but
		// doesn't change the size of the data structure
		try {
			list.set(0, "X");
		} catch (Exception e) {
			Print.print("set(): " + e);
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		List<String> list = 
				Arrays.asList("A B C D E F G H I J K L".split(" "));
		test("Modifiable Copy", new ArrayList<String>(list));
		test("Arrays.asList()", list);
		test("unmodifiableList()", Collections.unmodifiableList(
				new ArrayList<String>(list)));

	}
}
