/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.enumerated;

import java.text.DateFormat;
import java.util.Date;

import net.sourceforge.mysources.thinkinjava4.utils.Print;
/**
 * 我们可以为enum实例编写方法，从而为每个enmu实例赋予各自不同的
 * 行为
 *
 * @author Lucky Yang
 * @since 0.1
 */
public enum ConstantSpecificMethod {
	DATE_TIEM{
		String getInfo(){
			return DateFormat.getDateInstance().format(new Date());
		}
	},
	
	CLASSPATH{
		String getInfo(){
			return System.getenv("CLASSPATH");
		}		
	},
	
	VERSION{
		String getInfo(){
			return System.getenv("java.version");
		}		
	};
	
	abstract String getInfo();
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		for(ConstantSpecificMethod csm : ConstantSpecificMethod.values()){
			Print.print(csm.getInfo());
		}
	}	
}
