/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.enumerated;

import static net.sourceforge.mysources.thinkinjava4.utils.Print.*;

/**
 * 演示了一些Enum提供的功能
 *
 * @author Lucky Yang
 * @since 0.1
 */

enum Shrubbery {GROUND, CRAWLING, HANGING}

public class EnumClass {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		for(Shrubbery s : Shrubbery.values()){
			print(s + " ordinal:" + s.ordinal());
			printnb(s.compareTo(Shrubbery.CRAWLING) + " ");
			printnb(s.equals(Shrubbery.CRAWLING) + " ");
			print(s == Shrubbery.CRAWLING);
			print(s.getDeclaringClass());
			print(s.name());
			print("-------------------------");
		}
		
		// Produce an enum value from a string name:
		for(String s : "HANGING CRAWLING GROUND".split(" ")){
			Shrubbery shrub = Enum.valueOf(Shrubbery.class, s);
			print(shrub);
		}
	}

}
