/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.enumerated;

import java.util.Random;

import net.sourceforge.mysources.thinkinjava4.utils.Generator;
import net.sourceforge.mysources.thinkinjava4.utils.Print;
/**
 * 创建一个enum时，可以实现一个或多个接口
 *
 * @author Lucky Yang
 * @since 0.1
 */

enum CartoonCharacter 
	implements Generator<CartoonCharacter>{
	SLAPPY, SPANKY, PUNCHY, SILLY, BOUNCY, NUTTY, BOB;

	private Random rand = new Random(47);
	
	@Override
	public CartoonCharacter next() {
		return values()[rand.nextInt(values().length)];
	}
	
}

public class EnumImplementation {
	public static <T> void printNext(Generator<T> rg){
		Print.print(rg.next() + ", ");
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// Choose any instance
		CartoonCharacter cc = CartoonCharacter.BOB;
		for(int i = 0; i < 10; i++){
			printNext(cc);
		}
	}
}
