/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.enumerated;

import java.util.EnumSet;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

import static net.sourceforge.mysources.thinkinjava4.enumerated.AlarmPoints.*;

/**
 * 使用EnumSet跟踪报警器的状态
 *
 * @author Lucky Yang
 * @since 0.1
 */
public class EnumSets {
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		EnumSet<AlarmPoints> points = EnumSet.noneOf(AlarmPoints.class); // empty set
		points.add(BATHROOM);
		Print.print(points);
		
		points.addAll(EnumSet.of(STAIR1, STAIR2, KITCHEN));
		Print.print(points);
		
		points = EnumSet.allOf(AlarmPoints.class);
		points.removeAll(EnumSet.of(STAIR1, STAIR2, KITCHEN));
		Print.print(points);
		
		points.removeAll(EnumSet.range(OFFICE1, OFFICE4));
		Print.print(points);
		
		points = EnumSet.complementOf(points);
		Print.print(points);
	}
}
