/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */

package net.sourceforge.mysources.thinkinjava4.enumerated;

import java.util.Random;

/**
 * 定义自动售货机输入
 *
 * @author Lucky Yang
 * @since 0.1
 */
public enum Input {
	NICKEL(5),
	DIME(10),
	QUARTER(25),
	DOLLAR(100),
	TOOTHPASTE(200),
	CHIPS(75),
	SODA(100),
	SOAP(50),
	ABORT_TRANSACTION{
		public int amount(){
			throw new RuntimeException("ABORT.amount()");
		}
	},
	STOP{ // This must be the last instance
		public int amount(){
			throw new RuntimeException("SHUT_DOWN.amount()");
		}
	};
	
	int value; // in cents
	Input(int value){this.value = value;}
	Input(){}
	int amount(){return value;}
	
	static Random rand = new Random(47);
	
	public static Input randomSelect(){
		// Don't include STOP
		return values()[rand.nextInt(values().length -1)];
	}
}
