/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */

package net.sourceforge.mysources.thinkinjava4.enumerated;

import java.util.Iterator;

import net.sourceforge.mysources.thinkinjava4.utils.Enums;

/**
 * 模拟邮件
 *
 * @author Lucky Yang
 * @since 0.1
 */
public class Mail {
	// The NO's lower the probability of random selection;
	enum GeneralDelivery {YES, NO1, NO2, NO3, NO4, NO5}
	enum Scannability{UNSCANNABLE, YES1, YES2, YES3, YES4 }
	enum Readability{ILLEGIBLE, YES1, YES2, YES3, YES4}
	enum Address{INCORRECT, OK1, OK2, OK3, OK4, OK5, OK6}
	enum ReturnAddress{MISSING,OK1, OK2, OK3, OK4, OK5}
	
	GeneralDelivery generalDelivery;
	Scannability scannability;
	Readability readability;
	Address address;
	ReturnAddress returnAddress;
	
	static long counter = 0;
	long id = counter++;
	
	public String toString(){return "Mail " + id;}
	
	public String details(){
		return toString() + 
			", General Delivery: " + this.generalDelivery +
			", Address Scanability: " + this.scannability +
			", Address Readability: " + this.readability +
			", Address Address: " + this.address + 
			", Return address: " + this.returnAddress;
	}
	
	//Generate test Mail
	public static Mail randomMail(){
		Mail m = new Mail();
		m.generalDelivery = Enums.random(GeneralDelivery.class);
		m.scannability = Enums.random(Scannability.class);
		m.readability = Enums.random(Readability.class);
		m.address = Enums.random(Address.class);
		m.returnAddress = Enums.random(ReturnAddress.class);
		
		return m;
	}
	
	public static Iterable<Mail> generator(final int count){
		return new Iterable<Mail>(){
			int n = count;
			@Override
			public Iterator<Mail> iterator() {
				return new Iterator<Mail>(){

					@Override
					public boolean hasNext() {
						return n-- > 0;
					}

					@Override
					public Mail next() {
						return Mail.randomMail();
					}

					@Override
					public void remove() {
						throw new UnsupportedOperationException();						
					}
					
				};
			}
			
		};
	}
}
