/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.enumerated;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 向enum中添加
 *
 * @author Lucky Yang
 * @since 0.1
 */
public enum OzWitch {
	// Instances must be defined first. before methods:
	WEST("Miss Gulch, aka the Wicked Witch of the west"),
	NORTH("Glinda, the Good Witch of the North"),
	EAST("Wicked Witch of the Wast, wearer of the Ruby " +
			"Slippers, crushed by Dorothy's house"),
	SOUTH("Good by inference, but missing");
	
	private String description;
	
	// Constructor must be package or private access;
	private OzWitch(String description){
		this.description = description;
	}

	public String getDescription() {
		return description;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		for(OzWitch witch : OzWitch.values()){
			Print.print(witch + ":" + witch.getDescription());
		}		
	}
}
