/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.enumerated;

import java.lang.reflect.Method;
import java.lang.reflect.Type;
import java.util.Set;
import java.util.TreeSet;

import net.sourceforge.mysources.thinkinjava4.utils.OSExecute;
import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * values()的神秘之处
 *
 * @author Lucky Yang
 * @since 0.1
 */

enum Explore {HERE, THERE}

public class Reflection {
	public static Set<String> analyze(Class<?> enumClass){
		Print.print("-------- Analyzing " + enumClass + " ----");
		Print.print("Interfaces:");
		for(Type t : enumClass.getGenericInterfaces()){
			Print.print(t);
		}
		
		Print.print("Base:" + enumClass.getSuperclass());
		Print.print("Methods: ");
		
		Set<String> methods = new TreeSet<String>();
		for(Method m : enumClass.getMethods()){
			methods.add(m.getName());
		}
		Print.print(methods);
		return methods;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Set<String> exploreMethods = analyze(Explore.class);
		Set<String> enumMethods = analyze(Enum.class);
		
		Print.print("Explore.containsAll(Enum)? " + 
				exploreMethods.containsAll(exploreMethods));
		
		Print.printnb("Explore.removeAll(Enum):");
		exploreMethods.removeAll(enumMethods);
		Print.print(exploreMethods);
		
		// Decompile the code for the enum;
		OSExecute.command("javap target/classes/org/jbook/thinkinjava4/enumclass/Explore");
	}
}
