/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */

package net.sourceforge.mysources.thinkinjava4.enumerated;

import net.sourceforge.mysources.thinkinjava4.utils.Enums;
import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 游戏工具
 *
 * @author Lucky Yang
 * @since 0.1
 */
public class RoShamBo {
	public static <T extends Competitor<T>> 
	void match(T a, T b){
		Print.print(a + " vs. " + b + ": " + a.compete(b));
	}
	
	public static <T extends Enum<T> & Competitor<T>>
	void play(Class<T> rsbClass, int size){
		for(int i = 0 ; i < size; i++)
			match(Enums.random(rsbClass), Enums.random(rsbClass));
	}
}
