/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */

package net.sourceforge.mysources.thinkinjava4.enumerated;

import java.util.Random;

import net.sourceforge.mysources.thinkinjava4.utils.Print;
/**
 * “石头，剪刀，布“ 游戏。接口实现
 *
 * @author Lucky Yang
 * @since 0.1
 */

interface Item{
	Outcome compete(Item it);
	Outcome eval(Paper p);
	Outcome eval(Scissors p);
	Outcome eval(Rock p);
}

class Paper implements Item{
	public Outcome compete(Item it){
		return it.eval(this);
	};
	public Outcome eval(Paper p){
		return Outcome.DRAW;
	};
	public Outcome eval(Scissors p){
		return Outcome.WIN;
	};
	public Outcome eval(Rock p){
		return Outcome.LOSE;
	};
	public String toString(){
		return "Paper";
	}
}

class Scissors implements Item{
	public Outcome compete(Item it){
		return it.eval(this);
	};
	public Outcome eval(Paper p){
		return Outcome.LOSE;
	};
	public Outcome eval(Scissors p){
		return Outcome.DRAW;
	};
	public Outcome eval(Rock p){
		return Outcome.WIN;
	};
	public String toString(){
		return "Scissors";
	}
}

class Rock implements Item{
	public Outcome compete(Item it){
		return it.eval(this);
	};
	public Outcome eval(Paper p){
		return Outcome.WIN;
	};
	public Outcome eval(Scissors p){
		return Outcome.LOSE;
	};
	public Outcome eval(Rock p){
		return Outcome.DRAW;
	};
	public String toString(){
		return "Rock";
	}
}

public class RoShamBo1 {
	static final int SIZE = 20;
	private static Random rand = new Random(47);
	public static Item newItem(){
		switch(rand.nextInt(3)){
		default:
		case 0: return new Scissors();
		case 1: return new Rock();
		case 2: return new Paper();
		}
	}
	public static void match(Item a, Item b){
		Print.print(a + " vs. " + b + ": " + a.compete(b));
	}
	public static void main(String[] args){
		for(int i = 0; i < SIZE; i++)
			match(newItem(), newItem());
	}
}
