/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */

package net.sourceforge.mysources.thinkinjava4.enumerated;

import static net.sourceforge.mysources.thinkinjava4.enumerated.Outcome.*;
/**
 * “石头，剪刀，布“ 游戏。使用常量相关的方法
 *
 * @author Lucky Yang
 * @since 0.1
 */
public enum RoShamBo3 implements Competitor<RoShamBo3>{
	PAPER{
		@Override
		public Outcome compete(RoShamBo3 it) {
			switch(it){
			default:
			case PAPER: return DRAW;
			case SCISSORS: return LOSE;
			case ROCK: return WIN;
			}
		}		
	},
	SCISSORS{
		@Override
		public Outcome compete(RoShamBo3 it) {
			switch(it){
			default:
			case PAPER: return WIN;
			case SCISSORS: return DRAW;
			case ROCK: return LOSE;
			}
		}		
	},
	ROCK{
		@Override
		public Outcome compete(RoShamBo3 it) {
			switch(it){
			default:
			case PAPER: return LOSE;
			case SCISSORS: return WIN;
			case ROCK: return DRAW;
			}
		}		
	};	
	public abstract Outcome compete(RoShamBo3 it);
	
	public static void main(String[] args){
		RoShamBo.play(RoShamBo3.class, 20);
	}
}
