/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */

package net.sourceforge.mysources.thinkinjava4.enumerated;

import static net.sourceforge.mysources.thinkinjava4.enumerated.Outcome.*;
/**
 * “石头，剪刀，布“ 游戏。使用常量相关的方 改进
 *
 * @author Lucky Yang
 * @since 0.1
 */
public enum RoShamBo4 implements Competitor<RoShamBo4>{
	PAPER{
		@Override
		public Outcome compete(RoShamBo4 opponent) {
			return compete(ROCK, opponent);
		}
		
	},
	SCISSORS{
		@Override
		public Outcome compete(RoShamBo4 opponent) {
			return compete(PAPER, opponent);
		}		
	},
	ROCK{
		@Override
		public Outcome compete(RoShamBo4 opponent) {
			return compete(SCISSORS, opponent);
		}

	
	};	
	public abstract Outcome compete(RoShamBo4 it);
	
	public Outcome compete(RoShamBo4 loser, RoShamBo4 opponent) {
		return ((opponent == this)? DRAW
				:(opponent == loser)? WIN : LOSE);
	}
	
	public static void main(String[] args){
		RoShamBo.play(RoShamBo4.class, 20);
	}
}

