/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.enumerated;

import net.sourceforge.mysources.thinkinjava4.utils.Enums;
import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 有一种更简洁的管理枚举的办法，就是将一个enum嵌套在
 * 另一个enum内
 *
 * @author Lucky Yang
 * @since 0.1
 */
public enum SecurityCategory {
	STOCK(Security.Stock.class),
	BOND(Security.Bond.class);
	
	interface Security{
		enum Stock implements Security{SHORT, LONG, MARGIN}
		enum Bond implements Security{MUNICIPAL, JUNK} 
	}
	
	private Security[] values;
	
	private SecurityCategory(Class<? extends Security> kind){
		values = kind.getEnumConstants();
	}
	
	public Security randomSelection(){
		return Enums.random(values);
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		for(int i = 0; i < 10; i++){
			SecurityCategory category = 
				Enums.random(SecurityCategory.class);
			
			Print.print(category + ":" + category.randomSelection());
		}
	}
}
