/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */

package net.sourceforge.mysources.thinkinjava4.enumerated;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * switch语句中的enum. 这个例子enum构造一个小型状态机
 *
 * @author Lucky Yang
 * @since 0.1
 */

// Define an enum type
enum Signal {GREEN, YELLOW, RED}

public class TrafficLight {
	Signal color = Signal.RED;
	
	public void change(){
		switch(color){
			// Note that you don't have to say Signal.RED
			// in the case statemnet;
			case RED: 
				color = Signal.GREEN;
				break;
			case GREEN:
				color = Signal.YELLOW;
				break;
			case YELLOW:
				color = Signal.RED;
				break;
		}
	}
	
	public String toString(){
		return "The traffic light is " + color;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		TrafficLight t = new TrafficLight();
		for(int i = 0; i < 7; i++){
			Print.print(t);
			t.change();
		}
	}
}
