/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.io;

import java.nio.charset.Charset;
import java.util.Iterator;
import java.util.SortedMap;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 显示字符集
 * <p>
 * Displays Charsets and aliases
 * 
 * @anthor Lucky Yang
 * @Date 2012-11-25
 * @since 1.0.0
 */
public class AvailableCharSets {
	public static void main(String[] args){
		SortedMap<String, Charset> charsets =
				Charset.availableCharsets();
		
		Iterator<String> it = charsets.keySet().iterator();
		while(it.hasNext()){		
			String csName = it.next();
			Print.printnb(csName);
			
			Iterator<String> aliases = charsets.get(csName).aliases().iterator();
			if (aliases.hasNext())
				Print.printnb(": ");
			while(aliases.hasNext()){
				Print.printnb(aliases.next());
				if (aliases.hasNext())
					Print.printnb(", ");	
			}
			Print.print();
		}
	}
}


