/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
/**
 * 
 */
package net.sourceforge.mysources.thinkinjava4.io;

import java.io.Externalizable;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * Reconstructing an externalizable object. 
 *
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2012-12-2
 * @since 1.0.0
 */
public class Blip3 implements Externalizable {
	private int i;
	private String s; // No Initialization
	public Blip3(){
		Print.print("Blip3 Constructor");
		// s, i not initialized
	}
	
	public Blip3(String x, int a){
		Print.print("Blip3(String x, int a)");
		s = x;
		i = a;
		// s & i initialized only in non-default constructor
	}

	public String toString(){return s + i;};
	
	/* (non-Javadoc)
	 * @see java.io.Externalizable#writeExternal(java.io.ObjectOutput)
	 */
	@Override
	public void writeExternal(ObjectOutput out) throws IOException {
		Print.print("Blip3.writeExternal");
		// You must do this
		out.writeObject(s);
		out.writeInt(i);
	}

	/* (non-Javadoc)
	 * @see java.io.Externalizable#readExternal(java.io.ObjectInput)
	 */
	@Override
	public void readExternal(ObjectInput in) throws IOException,
			ClassNotFoundException {
		Print.print("Blip3.readExternal");
		// You must do this
		s = (String)in.readObject();
		i = in.readInt();
	}

	public static void main(String[] args) throws FileNotFoundException, IOException, ClassNotFoundException{
		Print.print("Constructing objects:");
		Blip3 b3 = new Blip3("A String", 47);
		Print.print(b3);
		
		ObjectOutputStream o = new ObjectOutputStream(
				new FileOutputStream("Blip3.out"));
		o.writeObject(b3);
		o.close();
		
		// Now get it back
		ObjectInputStream in = new ObjectInputStream(
				new FileInputStream("Blip3.out"));
		Print.print("Recovering b3");
		b3 = (Blip3)in.readObject();
		Print.print(b3);
	}
}


