/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
/**
 * 
 */
package net.sourceforge.mysources.thinkinjava4.io;

import java.io.Externalizable;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 序列话控制
 * <p>
 * Simple use of Externalizable & a pitfall. 
 *
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2012-12-2
 * @since 1.0.0
 */
class Blip1 implements Externalizable{

	public Blip1() {
		Print.print("Blip1 Constructor");
	}

	/* (non-Javadoc)
	 * @see java.io.Externalizable#writeExternal(java.io.ObjectOutput)
	 */
	@Override
	public void writeExternal(ObjectOutput out) throws IOException {
		Print.print("Blip1.writeExternal");		
	}

	/* (non-Javadoc)
	 * @see java.io.Externalizable#readExternal(java.io.ObjectInput)
	 */
	@Override
	public void readExternal(ObjectInput in) throws IOException,
			ClassNotFoundException {
		Print.print("Blip1.readExternal");	
	}
	
}

class Blip2 implements Externalizable{

	Blip2() {
		Print.print("Blip2 Constructor");
	}

	/* (non-Javadoc)
	 * @see java.io.Externalizable#writeExternal(java.io.ObjectOutput)
	 */
	@Override
	public void writeExternal(ObjectOutput out) throws IOException {
		Print.print("Blip2.writeExternal");		
	}

	/* (non-Javadoc)
	 * @see java.io.Externalizable#readExternal(java.io.ObjectInput)
	 */
	@Override
	public void readExternal(ObjectInput in) throws IOException,
			ClassNotFoundException {
		Print.print("Blip2.readExternal");	
	}
	
}
public class Blips {

	/**
	 * @param args
	 * @throws IOException 
	 * @throws FileNotFoundException 
	 * @throws ClassNotFoundException 
	 */
	public static void main(String[] args) throws FileNotFoundException, IOException, ClassNotFoundException {
		Print.print("Constructing objects:");
		Blip1 b1 = new Blip1();
		Blip2 b2 = new Blip2();
		ObjectOutputStream o = new ObjectOutputStream(
				new FileOutputStream("Blips.out"));
		Print.print("Saving objects");
		o.writeObject(b1);
		o.writeObject(b2);
		o.close();
		
		// Now get them back
		ObjectInputStream in = new ObjectInputStream(
				new FileInputStream("Blips.out"));
		Print.print("Reconvering b1:");
		b1 = (Blip1)in.readObject();
		
		// OOPS! Throws an exception
		Print.print("Reconvering b2:");
		b2 = (Blip2)in.readObject();		
	}

}


