/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.io;

import java.io.File;
import java.io.FilenameFilter;
import java.util.Arrays;
import java.util.regex.Pattern;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 目录列表器，使用匿名内部类实现
 * <p>
 * Uses anonymous inner classes. 
 *
 * @anthor Lucky Yang
 * @Date 2012-11-17
 * @since 1.0.0
 */
public class DirList2 {
	public static FilenameFilter filter(final String regex){
		// Creation of anonymous inner class
		return new FilenameFilter(){
			private Pattern pattern = Pattern.compile(regex);
			
			@Override
			public boolean accept(File dir, String name) {
				return pattern.matcher(name).matches();
			}
			
		};
	}
	
	public static void main(String[] args){
		File path = new File(".");
		String[] list;
		if (args.length == 0)
			list = path.list();
		else
			list =path.list(filter(args[0]));
		Arrays.sort(list, String.CASE_INSENSITIVE_ORDER);
		for(String dirItem : list)
			Print.print(dirItem);		
	}
}


