/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.io;

import java.io.File;

import net.sourceforge.mysources.thinkinjava4.utils.Directory;
import net.sourceforge.mysources.thinkinjava4.utils.PPrint;
import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * Directory类使用例子。
 *
 * @anthor Lucky Yang
 * @Date 2012-11-18
 * @since 1.0.0
 */
public class DirectoryDemo {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// All directories
		PPrint.pprint(Directory.walk(".").dirs);
		
		// All files beginning with 'T'
		for(File file : Directory.local(".", "T.*"))
			Print.print(file);
		
		Print.print("-----------------------");
		
		// All Java files beginning with 'T'
		for(File file : Directory.walk(".", "T.*\\.java"))
			Print.print(file);
		
		Print.print("========================");
		
		// Class files containing 'Z' or 'z'
		for(File file : Directory.walk(".", "[Zz].*\\.class"))
			Print.print(file);
		
	}

}


