/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.io;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.Arrays;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 字节的存放次序
 * <p>
 * Endian differences and data storage. 
 *
 * @anthor Lucky Yang
 * @Date 2012-11-25
 * @since 1.0.0
 */
public class Endians {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ByteBuffer bb = ByteBuffer.wrap(new byte[12]);
		bb.asCharBuffer().put("abcdef");		
		Print.print(Arrays.toString(bb.array()));
		bb.rewind();
		
		bb.order(ByteOrder.BIG_ENDIAN); // 高位优先
		bb.asCharBuffer().put("abcdef");
		Print.print(Arrays.toString(bb.array()));
		bb.rewind();
		
		bb.order(ByteOrder.LITTLE_ENDIAN); // 低位优先
		bb.asCharBuffer().put("abcdef");
		Print.print(Arrays.toString(bb.array()));
		bb.rewind();	
		
	}

}


