/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.io;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 使用gzip进行简单的压缩
 *
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2012-12-1
 * @since 1.0.0
 */
public class GZIPcompress {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		if (args.length == 0){
			Print.print("Usage: \nGZIPcompress file\n" +
					"\tUses GZIP compression to compress " +
					"the file to test.gz");
			System.exit(1);
		}
		BufferedReader in = new BufferedReader(
				new FileReader(args[0]));
		BufferedOutputStream out = new BufferedOutputStream(
				new GZIPOutputStream(
						new FileOutputStream("test.gz")));
		
		Print.print("Writing file");
		int c;
		while((c = in.read()) != -1)
			out.write(c);
		in.close();
		out.close();
		
		Print.print("Reading file");
		BufferedReader in2 = new BufferedReader(
				new InputStreamReader(
						new GZIPInputStream(
								new FileInputStream("test.gz"))));
		String s;
		while((s = in2.readLine()) != null)
			Print.print(s);
	}

}


