/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.io;

import java.nio.ByteBuffer;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 获取基本类型
 * <p>
 * Getting different representations from a ByteBuffer 
 *
 * @anthor Lucky Yang
 * @Date 2012-11-25
 * @since 1.0.0
 */
public class GetData {
	private static final int BSIZE = 1024;
	public static void main(String[] args){
		ByteBuffer bb = ByteBuffer.allocate(BSIZE);
		
		// Allocation automatically zeroes the ByteBuffer
		int i = 0;
		while(i++ < bb.limit())
			if (bb.get() != 0)
				Print.print("nonzero");
		Print.print("i = " + i);
		bb.rewind();
		
		// Store and read a char array
		bb.asCharBuffer().put("Howdy!");
		char c;
		while((c = bb.getChar()) != 0)
			Print.printnb(c + " ");
		Print.print();
		bb.rewind();
		
		// Store and read a short
		bb.asShortBuffer().put((short)471142);
		Print.print(bb.getShort());
		bb.rewind();
		
		// Store and read an int
		bb.asIntBuffer().put(99471142);
		Print.print(bb.getInt());
		bb.rewind();
		
		// Store and read a float
		bb.asFloatBuffer().put(99471142);
		Print.print(bb.getFloat());
		bb.rewind();
		
		// Store and read a double
		bb.asDoubleBuffer().put(99471142);
		Print.print(bb.getDouble());
		bb.rewind();
	}
}



