/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.io;

import java.nio.ByteBuffer;
import java.nio.IntBuffer;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 视图缓冲器
 * <p>
 * Manipulating ints in a ByteBuffer with an IntBuffer 
 *
 * @anthor Lucky Yang
 * @Date 2012-11-25
 * @since 1.0.0
 */
public class IntBufferDemo {
	private static final int BSIZE = 1024;
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ByteBuffer bb = ByteBuffer.allocate(BSIZE);
		IntBuffer ib = bb.asIntBuffer();
		
		// Store an array of int
		ib.put(new int[]{11, 42, 47, 99, 143, 811, 1016});
		// Absolute location read and write
		ib.put(3, 1811);
		
		// Setting a new limit before rewinding the buffer
		ib.flip();
		while(ib.hasRemaining()){
			int i = ib.get();
			Print.print(i);
		}

	}

}


