/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.io;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 内存映射文件
 * <p>
 * Creating a very large file using mapping. 
 *
 * @anthor Lucky Yang
 * @Date 2012-11-25
 * @since 1.0.0
 */
public class LargeMappedFiles {
	static int length = 0x8FFFFFF; // 128 MB
	public static void main(String[] args) throws FileNotFoundException, IOException{
		MappedByteBuffer out = new RandomAccessFile("test.dat", "rw").getChannel()
				.map(FileChannel.MapMode.READ_WRITE, 0, length);
		
		for(int i = 0; i < length; i++)
			out.put((byte)'x');
		
		Print.print("Finished writing");
		
		for(int i = length/2; i < length/2 + 6; i++)
			Print.printnb((char)out.get(i));	
	}
}


