/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
/**
 * 
 */
package net.sourceforge.mysources.thinkinjava4.io;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.Date;
import java.util.concurrent.TimeUnit;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 瞬时关键字
 * <p>
 * Demonstrates the "transient" keyword. 
 *
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2012-12-2
 * @since 1.0.0
 */
public class Logon implements Serializable {
	private Date date = new Date();
	private String username;
	private transient String password;
	public Logon(String name, String pwd){
		username = name;
		password = pwd;
	}
	
	public String toString(){
		return "logon info: \n  username: " + username + 
				"\n  date: " + date + "\n  password:" + password;
	}
	
	public static void main(String[] args) throws FileNotFoundException, IOException, InterruptedException, ClassNotFoundException{
		Logon a = new Logon("Hulk", "myLittlePony");
		Print.print("logon a = " + a);
		ObjectOutputStream o = new ObjectOutputStream(
				new FileOutputStream("Logon.out"));
		o.writeObject(a);
		o.close();
		TimeUnit.SECONDS.sleep(1); // Delay
		
		// Now get them back
		ObjectInputStream in = new ObjectInputStream(
				new FileInputStream("Logon.out"));
		Print.print("Recoverint object at " + new Date());
		a = (Logon)in.readObject();
		Print.print("logon a = " + a);
	}
}


