/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.io;

import java.io.File;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 检查或创建目录
 * <p>
 * Demonstrates the use of the File class to create directories 
 * and manipulate files. 
 *
 * @anthor Lucky Yang
 * @Date 2012-11-18
 * @since 1.0.0
 */
public class MakeDirectories {
	private static void usage(){
		Print.print(
				"Usage: MakeDirectories path1 ...\n" +
				"Creates each path\n" +
				"Deletes each path\n" +
				"Usage:MakeDirectories -r path1 path2\n" +
				"Renames from path1 to path2");
		System.exit(1);
	}
	
	private static void fileData(File f){
		Print.print(
				"Absolute path: " + f.getAbsolutePath() +
				"\n Can read: " + f.canRead() +
				"\n Can write: " + f.canWrite() + 
				"\n getName: " + f.getName() +
				"\n getParent: " + f.getParent() +
				"\n getPath: " + f.getPath() + 
				"\n length: " + f.length() + 
				"\n lastModified: " + f.lastModified());
		if(f.isFile())
			Print.print("It's a file");
		else if(f.isDirectory())
			Print.print("It's a directory");
	}
	
	public static void main(String[] args){
		if (args.length < 1) usage();
		
		if (args[0].equals("-r")){
			if (args.length != 3) usage();
			
			File
				old = new File(args[1]),
				rname = new File(args[1]);
			old.renameTo(rname);
			fileData(old);
			fileData(rname);
			
			return;
		}
		
		int count = 0;
		boolean del = false;
		if (args[0].equals("-d")){
			count++;
			del = true;
		}
		
		count--;
		while(++count < args.length){
			File f = new File(args[count]);
			if(f.exists()){
				Print.print(f + " exists");
				if(del){
					Print.print("deleting..." + f);
					f.delete();
				}
			}
			else{// Does't exist
				if(!del){
					f.mkdirs();
					Print.print("created " + f);
				}
			}
			fileData(f);
		}
	}
}


