/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.io;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 使用“持久化”
 * <p>
 * 将共同引用的对象序列化和反序列化
 *
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2012-12-22
 * @since 1.0.0
 */
class House implements Serializable{};

class Animal implements Serializable{
	private String name;
	private House preferredHouse;
	
	Animal(String nm, House h){
		name = nm;
		preferredHouse = h;
	}
	
	public String toString(){
		return name + "[" + super.toString()
				+ "]," + preferredHouse + "\n";
	}
}

public class MyWorld {
	public static void main(String[] args) throws IOException, ClassNotFoundException{
		House house = new House();
		List<Animal> animals = new ArrayList<Animal>();
		animals.add(new Animal("Bosco the dog", house));
		animals.add(new Animal("Ralph the dog", house));
		animals.add(new Animal("Molly the dog", house));
		Print.print("animals:" + animals);
		
		ByteArrayOutputStream buf1 = new ByteArrayOutputStream();
		ObjectOutputStream o1 = new ObjectOutputStream(buf1);
		o1.writeObject(animals);
		o1.writeObject(animals); // Write a 2nd set
		
		// Write to a different stream
		ByteArrayOutputStream buf2 = new ByteArrayOutputStream();
		ObjectOutputStream o2 = new ObjectOutputStream(buf2);
		o2.writeObject(animals);
		
		// Now get the back
		ObjectInputStream in1 = new ObjectInputStream(
				new ByteArrayInputStream(buf1.toByteArray()));
		ObjectInputStream in2 = new ObjectInputStream(
				new ByteArrayInputStream(buf2.toByteArray())); 
		List animals1 = (List)in1.readObject(),
				animals2 = (List)in1.readObject(),
						animals3 = (List)in2.readObject();
		
		Print.print("animals1:" + animals1);
		Print.print("animals2:" + animals2);
		Print.print("animals3:" + animals3);
		
		
	}
}


