/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.io;

import java.io.IOException;
import java.util.ArrayList;


import net.sourceforge.mysources.thinkinjava4.utils.Print;
import nu.xom.Builder;
import nu.xom.Document;
import nu.xom.Elements;
import nu.xom.ParsingException;
import nu.xom.ValidityException;

/**
 * 从xml文件中反序列化Person对象
 * <p>
 * 注意：先运行Person类
 *
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2012-12-22
 * @since 1.0.0
 */
public class People extends ArrayList<Person> {
	public People(String fileName) throws ValidityException, ParsingException, IOException{
		Document doc = new Builder().build(fileName);
		Elements elements = doc.getRootElement().getChildElements();
		for(int i = 0; i < elements.size(); i++)
			add(new Person(elements.get(i)));
	}
	
	public static void main(String[] args) throws ValidityException, ParsingException, IOException{
		People p = new People("People.xml");
		Print.print(p);
	}
}


