/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
/**
 * 
 */
package net.sourceforge.mysources.thinkinjava4.io;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * Externalizable的替代方案
 * <p>
 * Controlling serialization by adding your own 
 * writeObject() and readObject() methods. 
 *
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2012-12-2
 * @since 1.0.0
 */
public class SerialCtl implements Serializable {
	private String a;
	private transient String b;
	public SerialCtl(String aa, String bb){
		a = "Not Transient:" + aa;
		b = "Transient:" + bb;
	}	
	public String toString(){return a + "\n" + b;}
	
	private void writeObject(ObjectOutputStream stream) throws IOException{
		stream.defaultWriteObject();
		stream.writeObject(b);
	}
	private void readObject(ObjectInputStream stream) throws ClassNotFoundException, IOException{
		stream.defaultReadObject();
		b = (String)stream.readObject();
	}
	
	public static void main(String[] args) throws IOException, ClassNotFoundException{
		SerialCtl sc = new SerialCtl("Test1", "Test2");
		Print.print("Before:\n" + sc);
		ByteArrayOutputStream buf = new ByteArrayOutputStream();
		ObjectOutputStream o = new ObjectOutputStream(buf);
		o.writeObject(sc);
		
		// Now get it back
		ObjectInputStream in = new ObjectInputStream(
				new ByteArrayInputStream(buf.toByteArray()));
		SerialCtl sc2 = (SerialCtl)in.readObject();
		Print.print("After:\n" + sc2);
	}
}


