/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.io;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 存储和恢复数据
 * <p>
 *
 * @anthor Lucky Yang
 * @Date 2012-11-23
 * @since 1.0.0
 */
public class StoringAndRecoveringData {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		DataOutputStream out = new DataOutputStream(
				new BufferedOutputStream(
						new FileOutputStream("Data.txt")));
		out.writeDouble(3.13159);
		out.writeUTF("That wa pi");
		out.writeDouble(1.41413);
		out.writeUTF("Square root of 2");
		out.close();
		
		DataInputStream in = new DataInputStream(
				new BufferedInputStream(
						new FileInputStream("Data.txt")));
		Print.print(in.readDouble());
		// Only readUTF() will recover the
		// Java-UTF String properly
		Print.print(in.readUTF());
		Print.print(in.readDouble());
		Print.print(in.readUTF());
	}

}


