/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.io;

import java.io.IOException;
import java.io.RandomAccessFile;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 读写随机访问文件
 *
 * @anthor Lucky Yang
 * @Date 2012-11-23
 * @since 1.0.0
 */
public class UsingRandomAccessFile {
	static String file = "rtest.dat";
	static void display() throws IOException{
		RandomAccessFile rf = new RandomAccessFile(file, "r");
		for(int i = 0; i < 7; i++)
			Print.print(
					"Value " + i + ": " + rf.readDouble());
		Print.print(rf.readUTF());
		rf.close();
	}
	
	public static void main(String[] args) throws IOException{
		RandomAccessFile rf = new RandomAccessFile(file, "rw");
		for(int i = 0; i < 7; i++)
			rf.writeDouble(i*1.414);
		rf.writeUTF("The end of the file");
		rf.close();
		display();
		
		rf = new RandomAccessFile(file, "rw");
		// Since a double  is always eight bytes long, to  seek( )  
		// to double number 5 you just multiply  5*8  to produce 
		// the seek value. 
		rf.seek(5*8);
		rf.writeDouble(47.0001);
		rf.close();
		display();
	}
}


