/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.io;

import java.nio.ByteBuffer;
import java.nio.CharBuffer;
import java.nio.DoubleBuffer;
import java.nio.FloatBuffer;
import java.nio.IntBuffer;
import java.nio.LongBuffer;
import java.nio.ShortBuffer;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 在ByteBuffer上建立不同的视图缓冲器
 * <p>
 *
 * @anthor Lucky Yang
 * @Date 2012-11-25
 * @since 1.0.0
 */
public class ViewBuffers {
	public static void main(String[] args){
		ByteBuffer bb = ByteBuffer.wrap(
				new byte[]{0, 0, 0, 0, 0, 0, 0, 'a'});
		bb.rewind();
		
		Print.printnb("Byte Buffer ");
		while(bb.hasRemaining())
			Print.printnb(bb.position() + " -> " + bb.get() + ", ");
		Print.print();
		
		CharBuffer cb = ((ByteBuffer)bb.rewind()).asCharBuffer();
		Print.printnb("Char Buffer ");
		while(cb.hasRemaining())
			Print.printnb(cb.position() + " -> " + cb.get() + ", ");
		Print.print();	
		
		FloatBuffer fb = ((ByteBuffer)bb.rewind()).asFloatBuffer();
		Print.printnb("Float Buffer ");
		while(fb.hasRemaining())
			Print.printnb(fb.position() + " -> " + fb.get() + ", ");
		Print.print();
		
		IntBuffer ib = ((ByteBuffer)bb.rewind()).asIntBuffer();
		Print.printnb("Int Buffer ");
		while(ib.hasRemaining())
			Print.printnb(ib.position() + " -> " + ib.get() + ", ");
		Print.print();	
		
		LongBuffer lb = ((ByteBuffer)bb.rewind()).asLongBuffer();
		Print.printnb("Long Buffer ");
		while(lb.hasRemaining())
			Print.printnb(lb.position() + " -> " + lb.get() + ", ");
		Print.print();
		
		ShortBuffer sb = ((ByteBuffer)bb.rewind()).asShortBuffer();
		Print.printnb("Long Buffer ");
		while(sb.hasRemaining())
			Print.printnb(sb.position() + " -> " + sb.get() + ", ");
		Print.print();
		
		DoubleBuffer db = ((ByteBuffer)bb.rewind()).asDoubleBuffer();
		Print.printnb("Double Buffer ");
		while(db.hasRemaining())
			Print.printnb(db.position() + " -> " + db.get() + ", ");		
	}
}


