/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.io;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.Random;

import net.sourceforge.mysources.thinkinjava4.utils.Print;

/**
 * 对象序列化
 * <p>
 * Demonstrates object serialization.
 *
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2012-12-1
 * @since 1.0.0
 */
class Data implements Serializable{
	private int n;
	public Data(int n){this.n = n;}
	public String toString(){return Integer.toString(n);}
}
public class Worm implements Serializable {
	private static Random rand = new Random(47);
	private Data[] d ={
			new Data(rand.nextInt(10)),
			new Data(rand.nextInt(10)),
			new Data(rand.nextInt(10))
	};
	private Worm next;
	private char c;
	// Value of i == number of segments
	public Worm(int i, char x){
		Print.print("Worm constructor: " + i);
		c = x;
		if(--i > 0)
			next = new Worm(i, (char)(x + 1));
	}
	public Worm(){
		Print.print("Default constructor");
	}
	public String toString(){
		StringBuilder result = new StringBuilder(":");
		result.append(c);
		result.append("(");
		for(Data dat : d)
			result.append(dat);
		result.append(")");
		if(next != null)
			result.append(next);
		return result.toString();
	}
	
	public static void main(String[] args) throws IOException, ClassNotFoundException{
		Worm w = new Worm(6, 'a');
		Print.print("w = " + w);
		
		ObjectOutputStream out = new ObjectOutputStream(
				new FileOutputStream("worm.out"));
		out.writeObject("Worm storage\n");
		out.writeObject(w);
		out.close(); // Also flushes output
		
		ObjectInputStream in = new ObjectInputStream(
				new FileInputStream("worm.out"));
		String s = (String)in.readObject();
		Worm w2 = (Worm)in.readObject();
		Print.print(s + "w2 = " + w2);
		
		ByteArrayOutputStream bout = new ByteArrayOutputStream();
		ObjectOutputStream out2 = new ObjectOutputStream(bout);
		out2.writeObject("Worm storage\n");
		out2.writeObject(w);
		out2.flush();
		
		ObjectInputStream in2 = new ObjectInputStream(
				new ByteArrayInputStream(bout.toByteArray()));
		s = (String)in2.readObject();
		Worm w3 = (Worm)in2.readObject();
		Print.print(s + "w3 = " + w3);
	}
}


