/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.utils;

import java.util.ArrayList;

/**
 * 使用“适配器”设计模式
 * <p>
 * A Collection filled with data using a generator object.
 * 
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2012-12-23
 * @since 1.1.2
 */
public class CollectionData<T> extends ArrayList<T> {
	public CollectionData(Generator<T> gen, int quantity) {
		for(int i = 0; i < quantity; i++){
			add(gen.next());
		}
	}

	// A generic convenience method
	public static <T> CollectionData<T> 
		list(Generator<T> gen, int quantity) {
		return new CollectionData<T>(gen, quantity);
	}
}
