/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.utils;

import java.util.AbstractList;

/**
 * List of any length, containing sample data. 
 *
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2012-12-29
 * @since 1.1.2
 */
public class CountingIntegerList extends AbstractList<Integer> {
	private int size;
	
	public CountingIntegerList(int size) {
		super();
		this.size = size < 0 ? 0 : size;
	}

	@Override
	public Integer get(int index) {
		return Integer.valueOf(index);
	}

	@Override
	public int size() {
		return size;
	}

	public static void main(String[] args){
		Print.print(new CountingIntegerList(30));
	}
}


