/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */

package net.sourceforge.mysources.thinkinjava4.utils;

import java.io.BufferedReader;
import java.io.InputStreamReader;

import static net.sourceforge.mysources.thinkinjava4.utils.Print.*;

/**
 * 进程控制，执行命令行命令
 * <p>
 * Run an operating system command and send the output to the console.
 *
 * @author Lucky Yang
 * @since 1.0.0
 */
public final class OSExecute {
	public static void command(String command){
		boolean err = false;
		try{
			Process process = new ProcessBuilder(command.split(" ")).start();
			BufferedReader results = new BufferedReader(
					new InputStreamReader(process.getInputStream()));
			
			String s;
			while((s = results.readLine()) != null){
				print(s);
			}
			
			BufferedReader errors = new BufferedReader(
					new InputStreamReader(process.getErrorStream()));
			// Report errors and return nonzero value
			// to calling process if there are problem:
			while((s = errors.readLine()) != null){
				print(s);
				err = true;
			}
		} catch(Exception e){
			// Compensate for Windows 2000, which throws an
			// exception for the default command line:
			if (!command.startsWith("CMD /C"))
				command("CMD /C" + command);
			else
				throw new RuntimeException(e);
		}
		if (err)
			throw new OSExecuteException("Errors executing " + command);
	}
	
}
