/**
   Copyright (C) 2012 . see<http://mysources.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.mysources.thinkinjava4.utils;

import java.util.Random;

/**
 * Generators that produce random values.
 *
 * @anthor Lucky Yang<1290308475@qq.com>
 * @Date 2012-12-23
 * @since 1.1.2
 */
public class RandomGenerator {
	private static Random r = new Random(47);
	public static class Boolean implements Generator<java.lang.Boolean>{
		@Override
		public java.lang.Boolean next() {
			return r.nextBoolean();
		}		
	}
	public static class Byte implements Generator<java.lang.Byte>{
		@Override
		public java.lang.Byte next() {
			return (byte)r.nextInt();
		}		
	}
	public static class Character implements Generator<java.lang.Character>{
		@Override
		public java.lang.Character next() {
			return CountingGenerator.chars[r.nextInt(
					CountingGenerator.chars.length)];
		}		
	}
	public static class String extends CountingGenerator.String{
		// plug in the random Character generator
		{cg = new Character();} // Instance initializer
		public String() {}
		public String(int length) {super(length);}		
	}	
	public static class Short implements Generator<java.lang.Short>{
		@Override
		public java.lang.Short next() {
			return (short)r.nextInt();
		}		
	}
	public static class Integer implements Generator<java.lang.Integer>{
		private int mod = 10000;
		public Integer(){};
		public Integer(int modulo){mod = modulo;}
		@Override
		public java.lang.Integer next() {
			return r.nextInt(mod);
		}		
	}
	public static class Long implements Generator<java.lang.Long>{
		private int mod = 10000;
		public Long(){};
		public Long(int modulo){mod = modulo;}
		@Override
		public java.lang.Long next() {
			return new java.lang.Long(r.nextInt(mod));
		}		
	}
	public static class Float implements Generator<java.lang.Float>{
		@Override
		public java.lang.Float next() {
			// Trim all but the first two decimal places
			int trimmed = Math.round(r.nextFloat() * 100);
			return ((float)trimmed)/100;
		}		
	}
	public static class Double implements Generator<java.lang.Double>{
		@Override
		public java.lang.Double next() {
			// Trim all but the first two decimal places
			long trimmed = Math.round(r.nextDouble() * 100);
			return ((double)trimmed)/100;
		}		
	}	
}


